/* Simple memory allocation test. */
#include <stdio.h>
#include <stdlib.h>

/* Demonstrates Variable-Length Array. */
int vla_test(int len) {
	char buf[len];  // <= VLA here
	int i;
	// Do some calculations for the array.
	for (i=0; i<len; i++) {
		buf[i] = i;
	}
	int j;
	for (i=0; i<len; i++) {
		j = buf[i];
	}
	return j;
}


int main(int argc, char **argv) {
	char *data;
	// malloc() some.
	data = malloc(1000);
	printf("Data = 1000 (%p), sum %d\n",data,vla_test(1000));
	// Make a too-large realloc()
	data = realloc(data,1000000000000000);
	// data is now NULL, since realloc() failed!
	printf("Data = 10000 (%p)\n",data);
	// We're free()ing NULL!  This is not good form.
	free(data);
	printf("All done\n");
	return 0;
}

/* // Proper way to reallocate memory:
	char *data; // my data
	void *tmp;  // temporary pointer
	data = malloc(100);
	tmp = realloc(data,1000000000000000);
	if (tmp == NULL) {
		// failed to allocate more memory. 
	} else {
		data = tmp; // Replace the original pointer.
	}
	free(data);
*/

